//
// User.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct User: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var realm: String?
    public var email: String?
    public var username: String?
    public var firstName: String?
    public var lastName: String?
    public var phone: String?
    public var phoneVerified: Bool?
    public var smsVerificationCode: Int?
    public var profileImage: String?
    public var location: Location?
    public var newUser: Bool?
    public var emailVerified: Bool?
    public var verificationToken: String?
    public var parentId: Int?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var member: Member?
    public var publisher: Publisher?
    public var shopper: Shopper?
    public var usages: [ApiUsage]?
    public var favorites: [Favorite]?
    public var shareReceivers: [Share]?
    public var shareSenders: [Share]?
    public var transactions: [Transaction]?
    public var trials: [Trial]?

    public init(id: Int? = nil, realm: String? = nil, email: String? = nil, username: String? = nil, firstName: String? = nil, lastName: String? = nil, phone: String? = nil, phoneVerified: Bool? = nil, smsVerificationCode: Int? = nil, profileImage: String? = nil, location: Location? = nil, newUser: Bool? = nil, emailVerified: Bool? = nil, verificationToken: String? = nil, parentId: Int? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, member: Member? = nil, publisher: Publisher? = nil, shopper: Shopper? = nil, usages: [ApiUsage]? = nil, favorites: [Favorite]? = nil, shareReceivers: [Share]? = nil, shareSenders: [Share]? = nil, transactions: [Transaction]? = nil, trials: [Trial]? = nil) {
        self.id = id
        self.realm = realm
        self.email = email
        self.username = username
        self.firstName = firstName
        self.lastName = lastName
        self.phone = phone
        self.phoneVerified = phoneVerified
        self.smsVerificationCode = smsVerificationCode
        self.profileImage = profileImage
        self.location = location
        self.newUser = newUser
        self.emailVerified = emailVerified
        self.verificationToken = verificationToken
        self.parentId = parentId
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.member = member
        self.publisher = publisher
        self.shopper = shopper
        self.usages = usages
        self.favorites = favorites
        self.shareReceivers = shareReceivers
        self.shareSenders = shareSenders
        self.transactions = transactions
        self.trials = trials
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case realm
        case email
        case username
        case firstName
        case lastName
        case phone
        case phoneVerified
        case smsVerificationCode
        case profileImage
        case location
        case newUser
        case emailVerified
        case verificationToken
        case parentId
        case updatedAt
        case createdAt
        case member = "Member"
        case publisher = "Publisher"
        case shopper = "Shopper"
        case usages = "Usages"
        case favorites = "Favorites"
        case shareReceivers = "ShareReceivers"
        case shareSenders = "ShareSenders"
        case transactions = "Transactions"
        case trials = "Trials"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(realm, forKey: .realm)
        try container.encodeIfPresent(email, forKey: .email)
        try container.encodeIfPresent(username, forKey: .username)
        try container.encodeIfPresent(firstName, forKey: .firstName)
        try container.encodeIfPresent(lastName, forKey: .lastName)
        try container.encodeIfPresent(phone, forKey: .phone)
        try container.encodeIfPresent(phoneVerified, forKey: .phoneVerified)
        try container.encodeIfPresent(smsVerificationCode, forKey: .smsVerificationCode)
        try container.encodeIfPresent(profileImage, forKey: .profileImage)
        try container.encodeIfPresent(location, forKey: .location)
        try container.encodeIfPresent(newUser, forKey: .newUser)
        try container.encodeIfPresent(emailVerified, forKey: .emailVerified)
        try container.encodeIfPresent(verificationToken, forKey: .verificationToken)
        try container.encodeIfPresent(parentId, forKey: .parentId)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(member, forKey: .member)
        try container.encodeIfPresent(publisher, forKey: .publisher)
        try container.encodeIfPresent(shopper, forKey: .shopper)
        try container.encodeIfPresent(usages, forKey: .usages)
        try container.encodeIfPresent(favorites, forKey: .favorites)
        try container.encodeIfPresent(shareReceivers, forKey: .shareReceivers)
        try container.encodeIfPresent(shareSenders, forKey: .shareSenders)
        try container.encodeIfPresent(transactions, forKey: .transactions)
        try container.encodeIfPresent(trials, forKey: .trials)
    }
}

